import { Platform } from '@angular/cdk/platform';
import { ChangeDetectorRef, DoCheck, ElementRef, OnDestroy } from '@angular/core';
import { ControlValueAccessor, FormGroupDirective, NgControl, NgForm } from '@angular/forms';
import { CanUpdateErrorState, ErrorStateMatcher, ThemePalette } from '@angular/material/core';
import { MatFormFieldControl } from '@angular/material/form-field';
import { _MatInputMixinBase } from '@angular/material/input';
import { Subject } from 'rxjs';
import { FileOrArrayFile } from './file-input-type';
export declare class NgxMatFileInputIcon {
}
export declare class NgxMatFileInputComponent extends _MatInputMixinBase implements MatFormFieldControl<FileOrArrayFile>, OnDestroy, DoCheck, CanUpdateErrorState, ControlValueAccessor {
    protected _elementRef: ElementRef<HTMLInputElement | HTMLSelectElement | HTMLTextAreaElement>;
    protected _platform: Platform;
    private _cd;
    ngControl: NgControl;
    private _inputFileRef;
    private _inputValueRef;
    /** Custom icon set by the consumer. */
    _customIcon: NgxMatFileInputIcon;
    color: ThemePalette;
    fileNames: string;
    protected _uid: string;
    protected _previousNativeValue: any;
    _ariaDescribedby: string;
    readonly stateChanges: Subject<void>;
    focused: boolean;
    errorState: boolean;
    controlType: string;
    autofilled: boolean;
    /** Function when touched */
    _onTouched: () => void;
    /** Function when changed */
    _onChange: (value: FileOrArrayFile) => void;
    disabled: boolean;
    protected _disabled: boolean;
    id: string;
    protected _id: string;
    multiple: boolean;
    protected _multiple: boolean;
    placeholder: string;
    separator: string;
    required: boolean;
    protected _required: boolean;
    errorStateMatcher: ErrorStateMatcher;
    value: FileOrArrayFile;
    protected _value: FileOrArrayFile;
    readonly: boolean;
    private _readonly;
    /**
     * Limiting accepted file types
     * Example: accept="image/png, image/jpeg" or accept=".png, .jpg, .jpeg" — Accept PNG or JPEG files.
     */
    accept: string;
    private _accept;
    constructor(_elementRef: ElementRef<HTMLInputElement | HTMLSelectElement | HTMLTextAreaElement>, _platform: Platform, _cd: ChangeDetectorRef, ngControl: NgControl, _parentForm: NgForm, _parentFormGroup: FormGroupDirective, _defaultErrorStateMatcher: ErrorStateMatcher);
    ngOnChanges(): void;
    ngOnDestroy(): void;
    ngDoCheck(): void;
    writeValue(value: FileOrArrayFile): void;
    registerOnChange(fn: (value: any) => void): void;
    registerOnTouched(fn: () => void): void;
    setDisabledState(isDisabled: boolean): void;
    /** Focuses the input. */
    focus(options?: FocusOptions): void;
    _focusChanged(isFocused: boolean): void;
    /** Mark the field as touched */
    _markAsTouched(): void;
    protected _isBadInput(): boolean;
    readonly empty: boolean;
    readonly shouldLabelFloat: boolean;
    setDescribedByIds(ids: string[]): void;
    openFilePicker(event?: MouseEvent): void;
    handleFiles(filelist: FileList): void;
    /** Handles a click on the control's container. */
    onContainerClick(event: MouseEvent): void;
    private _resetInputFile;
    private _updateInputValue;
}
